<template>
  <div>
    <h2 id="page-heading" data-cy="VacunaHeading">
      <span v-text="$t('gatewayApp.biologicoVacuna.home.title')" id="vacuna-heading">Vacunas</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.biologicoVacuna.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'VacunaCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-vacuna"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.biologicoVacuna.home.createLabel')"> Create a new Vacuna </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && vacunas && vacunas.length === 0">
      <span v-text="$t('gatewayApp.biologicoVacuna.home.notFound')">No vacunas found</span>
    </div>
    <div class="table-responsive" v-if="vacunas && vacunas.length > 0">
      <table class="table table-striped" aria-describedby="vacunas">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('nombreVacuna')">
              <span v-text="$t('gatewayApp.biologicoVacuna.nombreVacuna')">Nombre Vacuna</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'nombreVacuna'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('tipoVacuna')">
              <span v-text="$t('gatewayApp.biologicoVacuna.tipoVacuna')">Tipo Vacuna</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'tipoVacuna'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('descripcionVacuna')">
              <span v-text="$t('gatewayApp.biologicoVacuna.descripcionVacuna')">Descripcion Vacuna</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'descripcionVacuna'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fechaIngreso')">
              <span v-text="$t('gatewayApp.biologicoVacuna.fechaIngreso')">Fecha Ingreso</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fechaIngreso'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('loteVacuna')">
              <span v-text="$t('gatewayApp.biologicoVacuna.loteVacuna')">Lote Vacuna</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'loteVacuna'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fabricante.id')">
              <span v-text="$t('gatewayApp.biologicoVacuna.fabricante')">Fabricante</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fabricante.id'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="vacuna in vacunas" :key="vacuna.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'VacunaView', params: { vacunaId: vacuna.id } }">{{ vacuna.id }}</router-link>
            </td>
            <td>{{ vacuna.nombreVacuna }}</td>
            <td>{{ vacuna.tipoVacuna }}</td>
            <td>{{ vacuna.descripcionVacuna }}</td>
            <td>{{ vacuna.fechaIngreso ? $d(Date.parse(vacuna.fechaIngreso), 'short') : '' }}</td>
            <td>{{ vacuna.loteVacuna }}</td>
            <td>
              <div v-if="vacuna.fabricante">
                <router-link :to="{ name: 'FabricanteView', params: { fabricanteId: vacuna.fabricante.id } }">{{
                  vacuna.fabricante.id
                }}</router-link>
              </div>
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'VacunaView', params: { vacunaId: vacuna.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'VacunaEdit', params: { vacunaId: vacuna.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(vacuna)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span id="gatewayApp.biologicoVacuna.delete.question" data-cy="vacunaDeleteDialogHeading" v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-vacuna-heading" v-text="$t('gatewayApp.biologicoVacuna.delete.question', { id: removeId })">
          Are you sure you want to delete this Vacuna?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-vacuna"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeVacuna()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./vacuna.component.ts"></script>
